﻿$engine JScript
$nodebug
$uname stdcommands
$dname Стандартные команды
// Описание различных стандартных команд Конфигуратора
// Список не полон, и пополняется по мере исследований.
// Динамически формирует макросы для вызова команд.
// Также создает удобные обертки для вызова команд.
// Например вместо
//  if(getCommandState("{F10CBB81-F679-11D4-9DD3-0050BAE2BC79}", 3).enabled)
//      sendCommand("{F10CBB81-F679-11D4-9DD3-0050BAE2BC79}", 3)
// можно писать
//  if(stdcommands.Config.Save.getState().enabled)
//      stdcommands.Config.Save.send()
// Предварительно надо подключить этот скрипт к своему скрипту:
//  SelfScript.AddNamedItem("stdcommands", addins.byUniqueName("stdcommands").object)
// либо с версии 23 добавив в начало скрипта строку
//  $addin stdcommands

// Описание командной группы
function CommandGroup(groupID, description)
{
    this.groupID = groupID
    this.description = description
}

// Описание команды
function Command(groupID, num, description)
{
    this.groupID = groupID
    this.number = num
    this.description = description
}

// Создание команды в группе
CommandGroup.prototype.cc = function(number, name, description)
{
    this[name] = new Command(this.groupID, number, description)
}

Command.prototype.getState = function(view)
{
    if(!view)
        view = Designer
    delete this.subStates
    var state = view.getCmdState(this.groupID, this.number)
    if(state && state.subCommands)
    {
        this.subStates = new Array()
        for(var i = 0; i < state.subCommands; i++)
            this.subStates.push(view.getCmdState(this.groupID, this.number, i))
    }
    return state
}

Command.prototype.send = function(subCommand)
{
    return sendCommand(this.groupID, this.number, subCommand)
}

Command.prototype.sendToView = function(view, subCommand)
{
    return view.sendCommand(this.groupID, this.number, subCommand)
}

Command.prototype.addHandler = function(obj, member)
{
    events.addCommandHandler(this.groupID, this.number, obj, member)
}

Command.prototype.delHandler = function(obj, member)
{
    events.delCommandHandler(this.groupID, this.number, obj, member)
}

// Описание групп команд
Frame       = new CommandGroup("{00000000-0000-0000-0000-000000000000}", "Основные команды меню")
Config      = new CommandGroup("{F10CBB81-F679-11D4-9DD3-0050BAE2BC79}", "Конфигурация")
// К сожалению, имя Debug - нельзя использовать
CDebug      = new CommandGroup("{DE680E96-5826-4E22-834D-692E307A1D9C}", "Отладчик")
Frntend     = new CommandGroup("{6B7291BF-BCD2-41AF-BAC7-414D47CC6E6A}", "Команды frnteеnd'а")
TextEdit    = new CommandGroup("{FFE26CB2-322B-11D5-B096-008048DA0765}", "Команды текстового редактора")
MngFormEdt  = new CommandGroup("{28CC865A-72ED-46BD-A236-C871EDDC3DFD}", "Редактор управляемых форм")
ModulePass  = new CommandGroup("{EF6D156B-12FB-4CE7-A0E9-7F0C2EDC7D06}", "Установка пароля на модуль")

Config.cc(2,    'Open',                 "Открыть конфигурацию")
Config.cc(3,    'Save',                 "Сохранить конфигурацию")
Config.cc(4,    'Close',                "Закрыть конфигурацию")
Config.cc(5,    'Window',               "Активировать окно конфигурации")
Config.cc(6,    'LoadFromFile',         "Загрузить конфигурацию из файла")
Config.cc(7,    'SaveToFile',           "Сохранить конфигурацию в файл")
Config.cc(8,    'FindResultWnd',        "Активировать окно с результатми поиска")
Config.cc(9,    'SyntaxCheck',          "Синтаксическая проверка модулей")
Config.cc(10,   'SyntaxHelper',         "Синтакс-помошник")
Config.cc(11,   'RunEnterprise',        "Запустить 1С-Предприятие")
Config.cc(12,   'SaveIBDataToFile',     "Сохранить данные из ИБ в файл")
Config.cc(14,   'LoadIBDataFromFile',   "Загрузить конфигурацию и данные из файла")
Config.cc(27,   'LoadChangedFromFile',  "Загрузить изменённую конфигурацию из файла")
Config.cc(28,   'Update',               "Обновить конфигурацию")
Config.cc(29,   'UpdateDBCfg',          "Обновить конфигурацию БД")
Config.cc(30,   'CompareDBCfg',         "Обновить/сравнить конфигурацию с конфигурацией БД")
Config.cc(31,   'SaveDBCfgToFile',      "Сохранить конфигурацию БД в файл")
Config.cc(32,   'RevertToDBCfg',        "Вернуться  к конфигурации БД")
Config.cc(33,   'TestAndRepair',        "Тестирование и исправление")
Config.cc(34,   'OpenDBCfg',            "Открыть конфигурацию БД")

CDebug.cc(1,    'Attach',               "Подключение")
CDebug.cc(2,    'Start',                "Начать отладку")
CDebug.cc(3,    'Restart',              "Перезапустить")
CDebug.cc(4,    'Break',                "Прекратить")
CDebug.cc(5,    'Stop',                 "Остановить")
CDebug.cc(6,    'StepIn',               "Шагнуть в")
CDebug.cc(7,    'StepTrought',          "Шагнуть через")
CDebug.cc(8,    'StepOut',              "Шагнуть из")
CDebug.cc(9,    'StepToCursor',         "Идти до курсора")
CDebug.cc(10,   'CurrentLine',          "Текущая строка")
CDebug.cc(11,   'Brkpt',                "Точка останова")
CDebug.cc(12,   'BrkptCond',            "Точка останова с условием")
CDebug.cc(13,   'BrkptOff',             "Отключить точку останова")
CDebug.cc(14,   'BrkptDel',             "Убрать все точки останова")
CDebug.cc(15,   'BrkptOffAll',          "Отключить все точки останова")
CDebug.cc(16,   'BrkptList',            "Список точек останова")
CDebug.cc(17,   'EvalExpr',             "Вычислить выражение")
CDebug.cc(18,   'Tablo',                "Табло")
CDebug.cc(19,   'CallStack',            "Стек вызовов")
CDebug.cc(20,   'Performance',          "Замер производительности")
CDebug.cc(21,   'BreakOnError',         "Остановка при ошибке")
CDebug.cc(22,   'GoToSource',           "Переход к строке, в которой установлена точка останова")
CDebug.cc(23,   'Dettach',              "Отключиться")

Frame.cc(1,     'FileNew',              "Новый документ")
Frame.cc(2,     'FileOpen',             "Открыть документ")
Frame.cc(3,     'FileClose',            "Закрыть документ")
Frame.cc(4,     'FileSave',             "Сохранить документ")
Frame.cc(5,     'FileSaveAs',           "Сохранить как")
Frame.cc(6,     'FileSaveCopy',         "Сохранить копию")
Frame.cc(8,     'RecentFile',           "MRU файл")
Frame.cc(9,     'CompareFiles',         "Сравнение файлов")
Frame.cc(20,    'Print',                "Печать")
Frame.cc(21,    'PrintDirect',          "Печать на текущий принтер")
Frame.cc(22,    'PrintPreview',         "Предварительный просмотр")
Frame.cc(23,    'PageSetup',            "Параметры страницы")
Frame.cc(24,    'PrintSetup',           "Параметры печати")
Frame.cc(40,    'Cut',                  "Вырезать")
Frame.cc(41,    'Copy',                 "Копировать в буфер")
Frame.cc(42,    'Paste',                "Вставить из буфера")
Frame.cc(43,    'PasteSpecial',         "Специальная вставка")
Frame.cc(44,    'SelectAll',            "Выбрать все")
Frame.cc(45,    'ClearSelection',       "Очистить выделенную область")
Frame.cc(46,    'Undo',                 "Отменить")
Frame.cc(47,    'Redo',                 "Вернуть")
Frame.cc(60,    'Search',               "Найти")
Frame.cc(101,   'GroupExpandWithIncluded',      "Развернуть группу c вложенными")
Frame.cc(102,   'GroupCollapseWithIncluded',    "Свернуть группу c вложенными") 
Frame.cc(103,   'GroupCollapse',        "Свернуть группу")
Frame.cc(104,   'GroupExpand',          "Развернуть группу")
Frame.cc(105,   'GroupCollapseAll',     "Свернуть все группы")
Frame.cc(106,   'GroupExpandAll',       "Развернуть все группы")
Frame.cc(260,   'Property',             "Свойства")
Frame.cc(324,   'GotoBack',             "Вернуться назад")
Frame.cc(325,   'GotoForward',          "Перейти вперед")
Frame.cc(600,   'ShowHelpAfterDot',     "Открыть подсказку после точки")
Frame.cc(810,   'DebugInThinClient',    "Запустить отладку в тонком клиенте")
Frame.cc(811,   'DebugInWebClient',     "Запустить отладку в веб-клиенте")
Frame.cc(812,   'DebugInThickMng',      "Запустить отладку в толстом клиенте (упр)")
Frame.cc(813,   'DebugInThickNoMng',    "Запустить отладку в толстом клиенте (обыч)")

Frntend.cc(1,   'MDReport',             "Отчет по конфигурации")
Frntend.cc(2,   'SelectSubSystem',      "Отбор по подсистемам")
Frntend.cc(10,  'MDSearchRefs',         "Поиск ссылок на объекты")
Frntend.cc(11,  'OpenModule',           "Открыть модуль объекта")
Frntend.cc(124, 'OpenManagerModule',    "Открыть модуль менеджера")
Frntend.cc(5,   'OpenMainForm',         "Открыть основную форму объекта")
Frntend.cc(7,   'OpenMainListForm',     "Открыть основную форму списка")
Frntend.cc(8,   'OpenMainSelectForm',   "Открыть основную форму выбора")
Frntend.cc(12,  'OpenMessageWindow',    "Открыть окно сообщений")
Frntend.cc(13,  'ClearMessageWindow',   "Очистить окно сообщений")
Frntend.cc(22,  'AddComments',          "Добавить комментарий")
Frntend.cc(23,  'DeleteComments',       "Удалить комментарий")
Frntend.cc(58,  'CloseMessageWindow',   "Закрыть окно сообщений")
Frntend.cc(56,  'SyntaxCheck',          "Синтакс-проверка текущего модуля")
Frntend.cc(14,  'OpenPicturesLib',      "Открыть библиотеку картинок конфигурации")
Frntend.cc(15,  'ConfigEditLang',       "Язык редактирования конфигурации")
Frntend.cc(82,  'FindRefsFrom',         "Поиск ссылок в объекте")
Frntend.cc(83,  'GoToDefinition',       "Перейти к определению")
Frntend.cc(63,  'QueryWizard',          "Конструктор запроса")
Frntend.cc(217, 'QueryWizardParam',     "Конструктор запроса с обработкой результата")
Frntend.cc(106, 'TextBlockEscapeNewline',  "Добавить перенос строки")
Frntend.cc(107, 'TextBlockUnescapeNewline', "Удалить перенос строки")

TextEdit.cc(1,  'ToggleBookmark',       "Установить/снять закладку")
TextEdit.cc(2,  'NextBookmark',         "Перейти к следующей закладке")
TextEdit.cc(3,  'PrevBookmark',         "Перейти к предшествующей закладке")
TextEdit.cc(4,  'ClearBookmarks',       "Удалить все закладки")
TextEdit.cc(5,  'ExtendersList',        "Список расширений")
TextEdit.cc(6,  'FormatSel',            "Форматировать блок")
TextEdit.cc(7,  'TabifySel',            "Сдвинуть блок вправо")
TextEdit.cc(8,  'UntabifySel',          "Сдвинуть блок влево")
TextEdit.cc(11, 'EndOfPage',            "Вставить конец страницы")
TextEdit.cc(12, 'Parameters',           "Параметры текстового редактора")
TextEdit.cc(15, 'GoToLine',             "Перейти к строке")
TextEdit.cc(16, 'SyntaxBlockEnd',       "Найти конец синтаксического блока")
TextEdit.cc(17, 'SynaxBlockBegin',      "Найти начало синтаксического блока")
TextEdit.cc(18, 'SyntaxBlockEndSel',    "Выделить все до конца синтаксического блока")
TextEdit.cc(19, 'SyntaxBlockBeginSel',  "Выделить все до начала синтаксического блока")
TextEdit.cc(20, 'SetHideMark',          "Отметить группу строк для скрытия")
TextEdit.cc(21, 'ClearHideMark',        "Снять отметку скрытия с группы строк")
TextEdit.cc(22, 'NextDiff',             "Следующее отличие")
TextEdit.cc(23, 'PrevDiff',             "Предшествующее отличие")
TextEdit.cc(24, 'SwapDiff',             "Переставить местами сравниваемые файла")
TextEdit.cc(25, 'TemplatesPopupList',   "Шаблоны в контекстном меню")
    
TextEdit.cc(56, 'ConfigTemplateFiles',  "Настроить список используемых файлов шаблонов")
TextEdit.cc(57, 'CreateNewTemplateFile',"Создать новый файл шаблонов")
TextEdit.cc(58, 'Templates',            "Шаблоны")
TextEdit.cc(61, 'ProcessTemplate',      "Обработка текущего слова шаблонами")
TextEdit.cc(62, 'ShowSubstString',      "Показывать строку автозамены в дереве шаблонов")
TextEdit.cc(66, 'FormatStringWizard',   "Запустить конструктор форматной строки")

MngFormEdt.cc(11, 'SwitchToForm',             "Переключиться на закладку 'Форма'")
MngFormEdt.cc(12, 'SwitchToModule',           "Переключиться на закладку 'Модуль'")
MngFormEdt.cc(13, 'SwitchToFormElements',     "Переключиться на закладку 'Форма' и активизировать закладку 'Элементы'")
MngFormEdt.cc(14, 'SwitchToFormProps',        "Переключиться на закладку 'Форма' и активизировать закладку 'Реквизиты'")
MngFormEdt.cc(15, 'SwitchToFormCommands',     "Переключиться на закладку 'Форма' и активизировать закладку 'Команды'")
MngFormEdt.cc(16, 'SwitchToFormComInterface', "Переключиться на закладку 'Форма' и активизировать закладку 'Командный интерфейс'")
MngFormEdt.cc(17, 'SwitchToFormParameter',    "Переключиться на закладку 'Форма' и активизировать закладку 'Параметры'")

// Команды табличного редактора (Пушин Владимир aka vladnet)
TableEdit    = new CommandGroup("{505A90DD-950E-4300-874D-8675BC2120B2}", "Команды табличного редактора")
TableEdit.cc(1,     'FixupGrid',        "Зафиксировать сетку")
Frame.cc(371,       'ShowTableGrid',    "Отображать сетку")
TableEdit.cc(12,    'ShowTitles',       "Отображать заголовки")
TableEdit.cc(13,    'ShowGroups',       "Отображать группы")
TableEdit.cc(14,    'Editing',          "Редактирование")
TableEdit.cc(30,    'ShowDescr',        "Отображать примечания")
TableEdit.cc(74,    'BWView',           "Черно-белый просмотр")
TableEdit.cc(704,   'PageViewMode',     "Режим просмотра страниц")
TableEdit.cc(540,   'Zoom50',           "Масштаб 50%")
TableEdit.cc(541,   'Zoom75',           "Масштаб 75%")
TableEdit.cc(542,   'Zoom100',          "Масштаб 100%")
TableEdit.cc(543,   'Zoom125',          "Масштаб 125%")
TableEdit.cc(544,   'Zoom150',          "Масштаб 150%")
TableEdit.cc(545,   'Zoom200',          "Масштаб 200%")
// Формат скрыть не пользовался у меня всегда не доступно
// Формат отобразить не пользовался у меня всегда не доступно
TableEdit.cc(24,    'RowHeight',        "Высота строк")
TableEdit.cc(25,    'ColumnWidth',      "Ширина колонок")
TableEdit.cc(7,     'Merge',            "Объединить в группу")
TableEdit.cc(8,     'Split',            "Исключить из группы")
TableEdit.cc(46,    'Names',            "Имена...")
TableEdit.cc(76,    'ShowNamedRowCols', "Отображение именованных строк/колонок")
TableEdit.cc(67,    'ShowNamedCells',   "Отображать именованные ячейки")
TableEdit.cc(77,    'AttachName',       "Назначить имя...")
TableEdit.cc(78,    'DetachName',       "Убрать имя")
TableEdit.cc(45,    'Headers',          "Колонтитулы...")
TableEdit.cc(41,    'SetPrintArea',     "Задать область печати")
TableEdit.cc(42,    'DelPrintArea',     "Удалить область печати")
TableEdit.cc(43,    'RepeatOnEachPage', "Повторять на каждом листе")
TableEdit.cc(44,    'DelRepeat',        "Удалить повторение")
TableEdit.cc(16,    'InsertPageBreak',  "Вставить разрыв страницы")
TableEdit.cc(17,    'DelPageBreak',     "Удалить разрыв страницы")
TableEdit.cc(4,     'Rectangle',        "Прямоугольник")
TableEdit.cc(5,     'Straight',         "Прямая")
TableEdit.cc(39,    'Oval',             "Овал")
TableEdit.cc(6,     'Text',             "Текст")
TableEdit.cc(9,     'Picture',          "Картинка...")
TableEdit.cc(68,    'Diagram',          "Диаграмма")
TableEdit.cc(69,    'GanttDiagram',     "Диаграмма Ганта")
TableEdit.cc(70,    'PivotDiagram',     "Сводная диаграмма")
TableEdit.cc(71,    'Dendrogram',       "Дендограмма")
TableEdit.cc(124,   'GraphicScheme',    "Графическая схема")
Frame.cc(173,       'InsertObject',     "Вставить объект...")
TableEdit.cc(37,    'Group',            "Сгруппировать")
TableEdit.cc(38,    'Ungroup',          "Разгруппировать")
TableEdit.cc(10,    'SelectDrawingObjs',"Выделение рисованных объектов")

TableEdit.cc(29,    'InsertDescr',      "Вставить примечание")
TableEdit.cc(52,    'DelDescr',         "Удалить примечание")
TableEdit.cc(111,   'PrevDescr',        "Предыдущее примечание")
TableEdit.cc(110,   'NextDescr',        "Следующее примечание")
TableEdit.cc(30,    'ShowDescr',        "Отображать примечания")

//?<{C86D2ADB-4832-4643-8A23-3145FD20515D}>?.cc(2,   '',             "Вставить сводную таблицу")
TableEdit.cc(101,   'DelPivotTable',    "Удалить сводную таблицу")
TableEdit.cc(2,     'Union',            "Объединить")
TableEdit.cc(3,     'Push',             "Раздвинуть")
Frame.cc(227,       'SplitCell',        "Разбить ячейку")
TableEdit.cc(90,    'GotoCell',         "Перейти к ячейке")
TableEdit.cc(65,    'EditingPanel',     "Панель редактирования")
TableEdit.cc(64,    'FixEditingPanel',  "Зафиксировать панель редактирования")

// Команды хранилища конфигурации.
CfgStore    = new CommandGroup("{5679B714-7E65-4ED4-92BF-6DDD604C6EA3}", "Хранилище конфигурации"); 
CfgStore.cc(150, 'GetFromCfgStore',                "Получить из хранилища");
CfgStore.cc(151, 'CaptureIntoCfgStore',                "Захватить в хранилище");
CfgStore.cc(152, 'StoreIntoCfgStore',                "Поместить в хранилище");
CfgStore.cc(153, 'CancelCaptureIntoCfgStore',                "Отменить захват в хранилище");
CfgStore.cc(200, 'OpenCfgStore',                "Открыть Хранилище");
CfgStore.cc(206, 'OpenCfgStoreHistory',         "Открыть Историю хранилища");
CfgStore.cc(207, 'OpenCfgStoreHistoryForObject',         "Открыть Историю хранилища для объекта");
CfgStore.cc(211, 'MergeCfgStoreWithObject',       "Сравнить хранилище с конфигурацией из файла");
CfgStore.cc(201, 'UpdateStatuses',              "Обновить статусы объектов в хранилище");
CfgStore.cc(154, 'UpdateConfigFromCfgStore',    "Обновить конфигурацию из хранилища");
CfgStore.cc(251, 'MergeConfigWithCfgStore',     "Сравнить/объединить конфигурацию с хранилищем");
CfgStore.cc(252, 'MergeCfgStoreWithFile',       "Сравнить хранилище с конфигурацией из файла");
CfgStore.cc(250, 'SaveCfgStoreToFile',          "Сохранить конфигурацию хранилища в файл");
CfgStore.cc(202, 'OpenCfgStoreAdmin',           "Администрирование хранилища");
CfgStore.cc(102, 'DisconnectFromCfgStore',      "Отключиться от хранилища");
CfgStore.cc(101, 'ConnectToCfgStore',           "Подключиться к хранилищу");
CfgStore.cc(104, 'CloseCfgStore',               "Закрыть хранилище");
CfgStore.cc(100, 'CreateCfgStore',              "Создать хранилище");

ModulePass.cc(0, 'SetPassword', 'Установить пароль на модуль');

function logCmdState(cmd, state, textDoc, subState)
{
    textDoc.ДобавитьСтроку("----------------------")
    textDoc.ДобавитьСтроку(cmd.description + " " + cmd.groupID + " " + cmd.number + (subState != undefined ? "/" + subState : ""))
    if(state)
    {
        textDoc.ДобавитьСтроку("Доступна: " + state.enabled)
        textDoc.ДобавитьСтроку("Пометка:  " + state.checked)
        textDoc.ДобавитьСтроку("Текст:    " + state.text)
        textDoc.ДобавитьСтроку("Описание: " + state.description)
        textDoc.ДобавитьСтроку("Тултип:   " + state.tooltip)
        textDoc.ДобавитьСтроку("Подкоманд:" + state.subCommands)
    }
    else
        textDoc.ДобавитьСтроку("Нет обработчика")
}

function TestForm()
{
    TestForm.one = this
    this.form = loadScriptForm("core\\std\\forms\\commands.ssf", this)
    this.form.CommandTree.Колонки.Добавить("object")
    for(var i in SelfScript.self)
    {
        if(SelfScript.self[i] instanceof CommandGroup)
        {
            var row = this.form.CommandTree.Строки.Добавить()
            row.Command = SelfScript.self[i].description ? SelfScript.self[i].description : i
            for(var k in SelfScript.self[i])
            {
                var cmd = SelfScript.self[i][k]
                if(cmd instanceof Command)
                {
                    var crow = row.Строки.Добавить()
                    crow.Command = cmd.description ? cmd.description : k
                    crow.object = cmd
                }
            }
        }
    }
}

TestForm.prototype.CommandTreeSelection = function(Control, RowSelected, Column, StandardProcessing)
{
    var cmd = RowSelected.val.object
    if(!cmd)
        return
    this.form.Закрыть()
    var state = cmd.getState()
    logCmdState(cmd, state, this.form.Controls.Output)
    if(cmd.subStates)
    {
        for(var k = 0; k < cmd.subStates.length; k++)
            logCmdState(cmd, cmd.subStates[k], this.form.Controls.Output, k)
    }
    if(!this.form.OnlyState)
        RowSelected.val.object.send()
    this.form.Открыть()
}

TestForm.prototype.TraceCommandsПриИзменении = function(Элемент)
{
    cmdTrace = this.form.TraceCommands
}

TestForm.prototype.ОбновлениеОтображения = function()
{
    this.form.TraceCommands = cmdTrace
}

function macrosTestCommand()
{
    if(!TestForm.one)
        new TestForm
    TestForm.one.form.Открыть()
}

// Создадим функцию с пробелами в имени
SelfScript.self['macrosПереключить трассировку команд'] = function()
{
    cmdTrace = !cmdTrace
    MessageBox("Трассировка команд в" + (cmdTrace ? "" : "ы") + "ключена", mbOK, "Снегопат", 1)
}

function addMacrosesForAllCommands()
{
    var self = SelfScript.self
    for(var i in self)
    {
        if(self[i] instanceof CommandGroup)
        {
            var name = self[i].description + ": "
            for(var k in self[i])
            {
                var cmd = self[i][k]
                if(cmd instanceof Command)
                {
                    var objName = i + "." + k
                    self["macros" + name + (cmd.description ? cmd.description : k)] =
                        new Function("return " + objName + ".send()")
                }
            }
        }
    }
}

// Создадим макросы для всех команд, для возможности привязки к хоткеям
addMacrosesForAllCommands()
