﻿$engine JScript
$nodebug
$uname hotkeys
$dname Работа с хоткеями

// Скрипт для работы с хоткеями

// Подготовка
var mapString2vkcodes = v8New("Соответствие")
var mapVkcodes2String = v8New("Соответствие")
var profileKey = "Snegopat/HotKeys"
var profileAddinsWithKey = "Snegopat/AddinsHotKeys"

fixupOldPredefVersion()
initCodes()
initHotKeys()
events.connect(Designer, "onLoadAddin", SelfScript.self)

function loadKeysFromValueTable(vt)
{
    HotKeys.ClearAll()
    // Окошко макросов должно быть всегда
    if(!vt.Найти('SnegopatMainScript::ВыбратьИВыполнитьМакрос', "Команда"))
    {
        var row = vt.Вставить(0)
        row.Команда = 'SnegopatMainScript::ВыбратьИВыполнитьМакрос'
        row.СочетаниеКлавиш = "Ctrl + M"
    }
    for(var rowenum = new Enumerator(vt); !rowenum.atEnd(); rowenum.moveNext())
    {
        var row = rowenum.item()
        var cmds = row.Команда.split("::")
        AddHotKey(row.СочетаниеКлавиш, cmds[0], cmds[1]);
    }
}

function initHotKeys()
{
    var vt = v8New("ТаблицаЗначений")
    vt.Колонки.Добавить("Команда")
    vt.Колонки.Добавить("СочетаниеКлавиш")
    profileRoot.createValue(profileKey, vt, pflSnegopat)
    loadKeysFromValueTable(profileRoot.getValue(profileKey))
    var addinsHotKeys = v8New("ТаблицаЗначений")
    addinsHotKeys.Колонки.Добавить("Addin")
    addinsHotKeys.Колонки.Добавить("Version")
    profileRoot.createValue(profileAddinsWithKey, addinsHotKeys, pflSnegopat)
}

function AddHotKey(str, addin, macros)
{
    HotKeys.add(stringTovkcode(str), addin, macros)
}

function stringTovkcode(str)
{
    var parts = str.split('+')
    var key = 0
    for(var i = 0; i < parts.length; i++)
    {
        var part = parts[i].replace(/^\s+|\s+$/g, '').toUpperCase()
        var res = mapString2vkcodes.Получить(part)
        if(res)
            key |= res
    }
    return key
}

function vkcodeToString(code)
{
    var str = ''
    if(code & hkCtrl)
        str += "Ctrl + "
    if(code & hkAlt)
        str += "Alt + "
    if(code & hkShift)
        str += "Shift + "
    var res = mapVkcodes2String.Получить(code & 0xFFFF)
    if(res)
        str += res
    return str
}

function PredefinedHotKeyReceiver()
{
    this.receiver = new Array()
    this.version = 0
}

PredefinedHotKeyReceiver.prototype.add = function(macros, hotkey)
{
    var pd = {macros:macros, hotkeys:new Array()}
    var allhk = hotkey.split("|")
    for(var k in allhk)
        pd.hotkeys.push(vkcodeToString(stringTovkcode(allhk[k])))
    this.receiver.push(pd)
}

PredefinedHotKeyReceiver.prototype.setVersion = function(version)
{
    this.version = version
}

function registerAddinHotkeys(addin)
{
    // Запросим у аддина предопределенные хоткеи
    if(!addin.object)
        return
    predefHotKeys = new PredefinedHotKeyReceiver()
    try{
        if(!addin.object.getPredefinedHotkeys)
            return
        addin.object.getPredefinedHotkeys(predefHotKeys)
    }
    catch(e)
    {
        return
    }
    // Проверим, регистрировал ли этот аддин свои хоткеи
    var addinsHotKey = profileRoot.getValue(profileAddinsWithKey)
    var row = addinsHotKey.Найти(addin.uniqueName, "Addin")
    if(row && row.Version == predefHotKeys.version)
        return
    // Аддин еще не регистрировал свои хоткеи
    // Будем добавлять
    // Для начала считаем уже установленные хоткеи
    var existHotKeys = profileRoot.getValue(profileKey)
    for(var i in predefHotKeys.receiver)
    {
        var hk = predefHotKeys.receiver[i]
        var macrosName = addin.uniqueName + "::" + hk.macros
        if(existHotKeys.Найти(macrosName, "Команда"))
            continue    // Для макроса уже есть хоткей
        // Теперь проверим конфликты по сочетаниям клавиш
        var hotKey = ""
        for(var k in hk.hotkeys)
        {
            if(!existHotKeys.Найти(hk.hotkeys[k], "СочетаниеКлавиш"))
            {
                // Такой хоткей еще не используется
                hotKey = hk.hotkeys[k]
                break
            }
        }
        var msg
        if(!hotKey.length)  // Все заданные аддином сочетания клавиш конфликтуют с кем либо
        {
            hotKey = hk.hotkeys[0]
            var rowEx = existHotKeys.Найти(hotKey, "СочетаниеКлавиш")
            msg = "Добавленный аддином '" + addin.uniqueName + "' хоткей '" + hotKey + "' для макроса '" +
                hk.macros + "' конфликтует с макросом '" + rowEx.Команда + "'"
        }
        else
            msg = "Аддин '" + addin.uniqueName + "' добавил хоткей  '" + hotKey + "' для макроса '" + hk.macros + "'"
        HotKeys.add(stringTovkcode(hotKey), addin.uniqueName, hk.macros)
        var rowhk = existHotKeys.Добавить()
        rowhk.Команда = macrosName
        rowhk.СочетаниеКлавиш = hotKey
        Message(msg)
    }
    // Теперь сохраним все
    if(!row)
    {
        row = addinsHotKey.Добавить()
        row.Addin = addin.uniqueName
    }
    row.Version = predefHotKeys.version
    profileRoot.setValue(profileKey, existHotKeys)
    profileRoot.setValue(profileAddinsWithKey, addinsHotKey)
    saveProfile()
}

function initCodes()
{
    function add(str, vkCode)
    {
        mapString2vkcodes.Вставить(str.toUpperCase(), vkCode)   
        mapVkcodes2String.Вставить(vkCode, str)
    }
    add('Ctrl', hkCtrl)
    add('Shift', hkShift)
    add('Alt', hkAlt)
    add('BkSpace', 0x8)
    add('Tab', 0x9)
    add('Enter', 0x0D)
    add('Esc', 0x1B)
    add('Space', 0x20)
    add('PgUp', 0x21)
    add('PgDn', 0x22)
    add('End', 0x23)
    add('Home', 0x24)
    add('Left', 0x25)
    add('Up', 0x26)
    add('Right', 0x27)
    add('Down', 0x28)
    add('Ins', 0x2D)
    add('Del', 0x2E)
    add('Num0', 0x60)
    add('Num1', 0x61)
    add('Num2', 0x62)
    add('Num3', 0x63)
    add('Num4', 0x64)
    add('Num5', 0x65)
    add('Num6', 0x66)
    add('Num7', 0x67)
    add('Num8', 0x68)
    add('Num9', 0x69)
    add('Num*', 0x6A)
    add('NumAdd', 0x6B)
    //add('NUMENTER', 0x6C) // Че-то не работает пока
    add('Num-', 0x6D)
    add('Num.', 0x6E)
    add('Num/', 0x6F)
    add('F1', 0x70)
    add('F2', 0x71)
    add('F3', 0x72)
    add('F4', 0x73)
    add('F5', 0x74)
    add('F6', 0x75)
    add('F7', 0x76)
    add('F8', 0x77)
    add('F9', 0x78)
    add('F10', 0x79)
    add('F11', 0x7A)
    add('F12', 0x7B)
    add('F13', 0x7C)
    add('F14', 0x7D)
    add('F15', 0x7E)
    add('F16', 0x7F)
    add('F17', 0x80)
    add('F18', 0x81)
    add('F19', 0x82)
    add('F20', 0x83)
    add('F21', 0x84)
    add('F22', 0x85)
    add('F23', 0x86)
    add('F24', 0x87)
    
    add(';', 0xBA)
    add('=', 0xBB)
    add(',', 0xBC)
    add('-', 0xBD)
    add('.', 0xBE)
    add('/', 0xBF)
    add('~', 0xC0)
    add('[', 0xDB)
    add('\\', 0xDC)
    add(']', 0xDD)
    add("'", 0xDE)
    
    for(var i = '0'.charCodeAt(0); i <= '9'.charCodeAt(0); i++)
        add(String.fromCharCode(i), i)
    for(var i = 'A'.charCodeAt(0); i <= 'Z'.charCodeAt(0); i++)
        add(String.fromCharCode(i), i)
}

function HotkeysWnd()
{
    if(!HotkeysWnd.one)
        HotkeysWnd.one = this
    this.form = loadScriptForm("core\\std\\forms\\hotkeys.ssf", this)
    this.fillTable()
}

HotkeysWnd.prototype.fillTable = function()
{
    this.form.Хоткеи.Очистить()
    // Заполняем текущими хоткеями
    for(var i = 0; i < HotKeys.count; i++)
    {
        var hk = HotKeys.item(i)
        var row = this.form.Хоткеи.Добавить()
        row.Команда = hk.addin + "::" + hk.macros
        row.СочетаниеКлавиш = vkcodeToString(hk.key)
    }
}

HotkeysWnd.prototype.ХоткеиСочетаниеКлавишНачалоВыбора = function(Элемент, СтандартнаяОбработка)
{
    var selector = new SelectHotKey()
    var result = selector.select(this.form.Controls.Хоткеи.ТекущаяСтрока.СочетаниеКлавиш)
    if(result)
        this.form.Controls.Хоткеи.ТекущаяСтрока.СочетаниеКлавиш = result
}

HotkeysWnd.prototype.ХоткеиКомандаНачалоВыбора = function(Элемент, СтандартнаяОбработка)
{
    var macrosSelect = addins.byUniqueName('macroswnd').object.getMacrosWnd()
    var res = macrosSelect.selectMacros()
    if(res)
        this.form.Controls.Хоткеи.ТекущаяСтрока.Команда = res.addin + "::" + res.macros
}

HotkeysWnd.prototype.MainCmdBarПрименить = function(Кнопка)
{
    // Установим все хоткееи
    loadKeysFromValueTable(this.form.Хоткеи)
    // Сохраним таблицу хоткеев в профайл
    profileRoot.setValue(profileKey, this.form.Хоткеи)
}

HotkeysWnd.prototype.MainCmdBarОтменить = function(Кнопка)
{
    this.fillTable()
}

function macrosРедактироватьГорячиеКлавиши()
{
    if(!HotkeysWnd.one)
        new HotkeysWnd()
    HotkeysWnd.one.form.Открыть()
}

function SelectHotKey()
{
    this.form = loadScriptForm("core\\std\\forms\\hotkeyselect.ssf", this)
}

SelectHotKey.prototype.select = function(current)
{
    var hk = stringTovkcode(current)
    this.form.Ctrl  = (hk & hkCtrl)  != 0
    this.form.Alt   = (hk & hkAlt)   != 0
    this.form.Shift = (hk & hkShift) != 0
    // заполняем список выбора
    for(var elements = new Enumerator(mapVkcodes2String); !elements.atEnd(); elements.moveNext())
    {
        var item = elements.item()
        if(item.Ключ < 256)
        {
            this.form.Controls.Key.СписокВыбора.Добавить(item.Значение)
            if(item.Ключ == (hk & 0xFFFF))
                this.form.key = item.Значение
        }
    }
    return this.form.ОткрытьМодально()
}

SelectHotKey.prototype.OKНажатие = function(Элемент)
{
    if(!this.form.key.length)
    {
        MessageBox("Не задана клавиша")
        return
    }
    var result = ""
    if(this.form.Ctrl)
        result += "Ctrl + "
    if(this.form.Alt)
        result += "Alt + "
    if(this.form.Shift)
        result += "Shift + "
    result += this.form.Key
    this.form.Закрыть(result)
}

function onLoadAddin(addin)
{
    registerAddinHotkeys(addin)
}

function fixupOldPredefVersion()
{
    var addinsHotKey = profileRoot.getValue(profileAddinsWithKey)
	try{
		addinsHotKey.Сортировать("Addin, Version")
		var prev = ''
		for(var i = addinsHotKey.Количество(); i--; )
		{
			var row = addinsHotKey.Get(i)
			if(row.Addin == prev)
				addinsHotKey.Delete(i)
			else
				prev = row.Addin
		}
		profileRoot.setValue(profileAddinsWithKey, addinsHotKey)
		saveProfile()
	}catch(e){}
}
