﻿$engine JScript
$nodebug
$uname macroswnd
$dname Показ окна макросов
$addin stdlib

// Скрипт для работы с окном макросов
// TODO - для скрипта stdcommands - выводить макросы также деревом для каждой группы команд

var PREFIX              = "::"
var PREFIX_GROUP        = "g" + PREFIX
var PREFIX_ADDIN        = "a" + PREFIX
var PREFIX_MACROS       = "m" + PREFIX
var modeSelectMacros    = 1
var modeSelectAddins    = 2
var modeSelectGroups    = 3

function MacrosWnd()
{
    if(!MacrosWnd.one)
        MacrosWnd.one = this
    this.form = loadScriptForm("core\\std\\forms\\macroses.ssf", this)
    this.form.MacrosTree.Колонки.Добавить("AddinAndMacrosName")
    this.lastMacros = ""
    this.filled = false
    this.mode = 0
    this.pattern = null
    this.form.Controls.Cmds.Кнопки.СделатьВыбор.СочетаниеКлавиш = stdlib.v8hotkey(13, 0)
    var self = this
    function update(pattern) { self.update(pattern) }
    stdlib.require('TextChangesWatcher.js', SelfScript)
    this.tc = new TextChangesWatcher(this.form.ЭлементыФормы.Pattern, 3, update)
    events.connect(Designer, "onLoadAddin", this, "onChangeAddin")
    events.connect(Designer, "onUnLoadAddin", this, "onChangeAddin")
}
MacrosWnd.one = null

MacrosWnd.prototype.isOpened = function()
{
    return this.form.Открыта()
}


MacrosWnd.prototype.onChangeAddin = function()
{
    this.filled = false
}

function testPattern(p, s)
{
    s = s.toLowerCase()
    for(var k in p)
        if(-1 == s.indexOf(p[k]))
            return false
    return true
}

MacrosWnd.prototype.processAddinsGroup = function(rows, group)
{
    for(var child = group.child; child; child = child.next)
    {
        if(!this.pattern)
        {
            var row = rows.Добавить()
            row.Addin = child.name
            row.AddinAndMacrosName = PREFIX_GROUP + child.name
            row.Картинка = 0
            this.processAddinsGroup(row.Строки, child)
            if(row.Строки.Количество() == 0)
                rows.Удалить(row)
        }
        else
            this.processAddinsGroup(rows, child)
    }
    if(this.mode == modeSelectGroups)
        return
    
    for(var i = 0, count = group.addinsCount; i < count; i++)
    {
        var addin = group.addin(i)
        var macroses = new VBArray(addin.macroses()).toArray()
        var un = addin.uniqueName
        var parentRows, prefix = addin.displayName + "::"
        
        for(var kk = macroses.length; kk--;)
        {
            // Удалим из списка макросы, начинающиеся с _, или не подходящие под шаблон при его наличии
            if(macroses[kk].substr(0, 1) == "_" || (this.pattern && !testPattern(this.pattern, prefix + macroses[kk])))
                macroses.splice(kk, 1)
        }
        
        if(this.mode == modeSelectAddins || (this.mode == modeSelectMacros && macroses.length))
        {
            // Если выводим по шаблону или всего один макрос, добавляем каждый макрос 
            // в общие строки, иначе для аддина заводим свой узел
            if((this.pattern || macroses.length == 1) && this.mode != modeSelectAddins)
                parentRows = rows
            else
            {
                prefix = ""
                var row = rows.Добавить()
                row.Addin = addin.displayName
                row.AddinAndMacrosName = PREFIX_ADDIN + un
                row.Картинка = 2
                parentRows = row.Строки
            }
            if(this.mode == modeSelectMacros)
            {
                for(var m in macroses)
                {
                    var macrosRow = parentRows.Добавить()
                    macrosRow.Addin = prefix + macroses[m]
                    macrosRow.Картинка = 1
                    macrosRow.AddinAndMacrosName = PREFIX_MACROS + un + PREFIX + macroses[m]
                    if(this.hotkeys.hasOwnProperty(macrosRow.AddinAndMacrosName))
                        macrosRow.Хоткей = this.hotkeys[macrosRow.AddinAndMacrosName]
                    if(macrosRow.AddinAndMacrosName == this.lastMacros)
                        this.lastMacrosRow = macrosRow
                }
            }
        }
    }
}

MacrosWnd.prototype.update = function(pattern)
{
    pattern = pattern.replace(/\s+/g, ' ').replace(/^\s|\s$/g, '')
    if(pattern.length)
        this.pattern = pattern.toLowerCase().split(' ');
    else
        this.pattern = null
    var currentRow = this.form.ЭлементыФормы.MacrosTree.ТекущаяСтрока
    this.lastMacros = currentRow ? currentRow.AddinAndMacrosName : ""
    this.lastMacrosRow = null
        
    this.form.MacrosTree.Строки.Очистить()
    this.processAddinsGroup(this.form.MacrosTree.Строки, addins.root)
    
    if(this.lastMacrosRow)
        this.form.ЭлементыФормы.MacrosTree.ТекущаяСтрока = this.lastMacrosRow
    else if(this.form.MacrosTree.Строки.Количество() > 0)
        this.form.ЭлементыФормы.MacrosTree.ТекущаяСтрока = this.form.MacrosTree.Строки.Get(0)
    if(!pattern.length)
        this.form.ТекущийЭлемент = this.form.ЭлементыФормы.MacrosTree
}

function findNextRowInTree(row, tree)
{
    if(tree.Развернут(row))
        return row.Строки.Получить(0)
    for(;;)
    {
        var parentRows = row.Parent ? row.Parent.Строки : row.Owner().Строки
        var rowIdx = parentRows.Индекс(row)
        if(rowIdx < parentRows.Количество() - 1)
            return parentRows.Получить(rowIdx + 1)
        row = row.Parent
        if(!row)
            break
    }
    return null
}

function findPrevRowInTree(row, tree)
{
    var parentRows = row.Parent ? row.Parent.Строки : row.Owner().Строки
    var rowIdx = parentRows.Индекс(row)
    if(0 == rowIdx)
        return row.Parent
    row = parentRows.Получить(rowIdx - 1)
    for(;;)
    {
        if(!tree.Развернут(row))
            return row
        parentRows = row.Строки
        row = parentRows.Получить(parentRows.Количество() - 1)
    }
}

MacrosWnd.prototype.PatternРегулирование = function(Элемент, Направление, СтандартнаяОбработка)
{
    var tp = this.form.Controls.MacrosTree, cr = tp.ТекущаяСтрока
    if(cr)
    {
        cr = (-1 == Направление.val ? findNextRowInTree : findPrevRowInTree)(cr, tp)
        if(cr)
            tp.ТекущаяСтрока = cr
    }
    СтандартнаяОбработка.val = false
}

MacrosWnd.prototype.CmdsСделатьВыбор = function()
{
    var tp = this.form.Controls.MacrosTree
    if(!tp.ТекущаяСтрока)
        return
    var selected = tp.ТекущаяСтрока.AddinAndMacrosName
    var prefixOfselected = selected.substr(0, 3)
    if(prefixOfselected != PREFIX_ADDIN && prefixOfselected != PREFIX_MACROS && prefixOfselected != PREFIX_GROUP) {
        this.form.Закрыть(false) //{addin: "", macros: ""})
        return
    }
    
    var str = selected.substr(3).split(PREFIX)
    var result
    
    if(prefixOfselected == PREFIX_ADDIN && this.mode == modeSelectAddins)
        result = {addin: str[0], macros: "", group: ""}
    else if(prefixOfselected == PREFIX_MACROS && this.mode == modeSelectMacros)
        result = {addin: str[0], macros: str[1], group: ""}
    else if(prefixOfselected == PREFIX_GROUP && this.mode == modeSelectGroups)
        result = {addin: "", macros: "", group: str[0]}
    if(result)
    {
        this.lastMacros = selected
        this.form.Закрыть(result)
    }
    else
    {
        if(tp.ТекущаяСтрока.Строки.Количество() > 0)
        {
            if(tp.Развернут(tp.ТекущаяСтрока))
                tp.Свернуть(tp.ТекущаяСтрока)
            else
                tp.Развернуть(tp.ТекущаяСтрока)
        }
    }
}

MacrosWnd.prototype.MacrosTreeВыбор = function()
{
	this.CmdsСделатьВыбор()
}

MacrosWnd.prototype.ПриОткрытии = function()
{
    this.tc.start()
}

MacrosWnd.prototype.ПриЗакрытии = function()
{
    this.tc.stop()
}

MacrosWnd.prototype.fillMacrosesTree = function(mode)
{
    this.mode = mode
    var caption
    switch(this.mode)
    {
    case modeSelectMacros:
        caption = "макрос"
        break
    case modeSelectAddins:
        caption = "аддин"
        break
    case modeSelectGroups:
        caption = "группу"
        break
        
    }
    this.form.Заголовок = "Выберите " + caption
    
    this.form.MacrosTree.Строки.Очистить()
    this.lastMacrosRow = null
    this.hotkeys = {}
    for(var i = 0; i < hotkeys.count; i++)
    {
        var hk = hotkeys.item(i)
        this.hotkeys[PREFIX_MACROS + hk.addin + PREFIX +  hk.macros] = hk.presentation
    }
    this.processAddinsGroup(this.form.MacrosTree.Строки, addins.root)
    if(this.lastMacrosRow)
    {
        this.form.ЭлементыФормы.MacrosTree.ТекущаяСтрока = this.lastMacrosRow
        this.lastMacrosRow = null
    }
    this.filled = true
}

MacrosWnd.prototype.selectMacros = function()
{
    if(!this.filled || this.mode != modeSelectMacros)
        this.fillMacrosesTree(modeSelectMacros)
    return this.form.ОткрытьМодально()
}

MacrosWnd.prototype.selectAddins = function()
{
    if(!this.filled || this.mode != modeSelectAddins)
        this.fillMacrosesTree(modeSelectAddins)
    return this.form.ОткрытьМодально()
}

MacrosWnd.prototype.selectGroups = function()
{
    if(!this.filled || this.mode != modeSelectGroups)
        this.fillMacrosesTree(modeSelectGroups)
    return this.form.ОткрытьМодально()
}

function getMacrosWnd()
{
    if(!MacrosWnd.one)
        new MacrosWnd()
    return MacrosWnd.one
}
